<?php
/** 
 *   This file provides the textual interface of WikkiTikkiTavi
 * For more information see http://tavi.sourceforge.net/TaviTranslation
 *
 *   This file is divided into the sections according to subdirectories of 
 * where the constants are used. So that the constant PARSE_RecentChanges are
 * to be found somewhere within the parse-subdirectory.
 *
 *   See http://tavi.sourceforge.net/TaviTranslation for notes on how to 
 * translate the file into another language, and how to publish your changes.
 * Please do contribute to make 'Tavi available in multiple languages. 
 *   The gist of translation, is to copy this file and translate it. Store the
 * resulting work as lang_XX.php, where XX denotes the two characters used to
 * describe the language. And after that to add a line like the following to
 * your config.php:
 *   setConst(LANGUAGE_CODE, 'cs');
 * Using 'cs' for the czech version, if available.
 */

/* General messages */
setConst('GEN_ErrorSuffix', 
       '<br />V ppad petrvvajcch problm kontaktuj <a href="mailto:' . 
       $Admin . '">administrtora</a>.');

/* action-directory */
setConst('ACTION_RateControlIpBlocking', 'Rate control / Blokovn IP adres je vypnuto');
setConst('ACTION_LockUnlockPages', 'Zamknout / odemknout dokumenty');
setConst('ACTION_BLockUnblockHosts', 'Zablokovat / odblokovat uivatele');
setConst('ACTION_ErrorNameMatch',
       'Zadal jsi neplatn uivatelsk jmno.' . GEN_ErrorSuffix);
setConst('ACTION_ErrorAdminDisabled',
       'Administrace nen v tto wiki k dispozici.'.GEN_ErrorSuffix);
setConst('ACTION_ErrorPageLocked',
       'Strnka, kterou chce upravit, je zamen.' . GEN_ErrorSuffix);

/* lib-directory */
setConst('LIB_ErrorDatabaseQuery', 
       'Nastala chyba pi zpracovn dotazu na databzi.' . GEN_ErrorSuffix);
setConst('LIB_ErrorDatabaseConnect', 
       'Nastala chyba pi pipojovn k databzi.' . GEN_ErrorSuffix); 
setConst('LIB_ErrorDatabaseSelect', 
       'Nastala chyba pi vbru databze.' . GEN_ErrorSuffix); 
setConst('LIB_ErrorCreatingTemp', 
       'Nastala chyba pi vytven pracovnho souboru.' . GEN_ErrorSuffix);
setConst('LIB_ErrorWritingTemp',
       'Nastala chyba pi zpisu do pracovnho souboru.' . GEN_ErrorSuffix);
// The next two entries are parsed through the wiki engine, so leave the \'\'
// to get bolded entries... And the escaping of $!DiffCmd...   ;)
setConst('LIB_NoDiffAvailableSafeMode',
       '\'\'Nelze zobrazit rozdly kvli patn cest v parametru diffcmd. Cesta '.
       'by mla bt v '. ini_get("safe_mode_exec_dir") .
       'a pitom je nastavena na '. $DiffCmd .'. Uprav si nastaven diffcmd nebo '.
       'si vytvo symbolick link na tento adres. Pot nezapome '.
       'upravit konfiguraci $!DiffCmd.\'\'');       
setConst('LIB_NoDiffAvailable',
       '\'\'Nelze zobrazit rozdly. $!DiffCmd ukazuje na soubor ' . $DiffCmd .
       ', kter neexistuje nebo je pokozen\'\'');
setConst('LIB_ErrorDeniedAccess',
       'Nem prva k pstupu na tyto strnky.' . GEN_ErrorSuffix);
setConst('LIB_ErrorRateExceeded',
       'Pekonal jsi limit potu strnek, kter me shldnout za urenou dobu.'.
       'Pokrauj v prohlen pozdji.' . GEN_ErrorSuffix);
setConst('LIB_ErrorInvalidPage',
       'Neplatn nzev strnky (dokumentu).' . GEN_ErrorSuffix);

/* parse-directory */
setConst('PARSE_Added', 'Pidno: ');
setConst('PARSE_Changed', 'Zmnno: ');
setConst('PARSE_Deleted', 'Smazno: ');
setConst('PARSE_Never', 'dn'); 
// The next two entries, are joined with a counting variable inbetween
setConst('PARSE_CompleteListStart', 'Zobrazit kompletn pehled (');
setConst('PARSE_CompleteListEnd',   ' zznam)');
setConst('PARSE_RecentChanges', 'Pehled zmn');
setConst('PARSE_Locked', 'Zamknout');
setConst('PARSE_BlockedRange', 'Blokovan IP adresy');
setConst('PARSE_EnterIpRange', 
       'Zadej rozsah IP adres ve form <tt>12.*</tt>, <tt>34.56.*</tt> nebo ' .
       '<tt>78.90.123.*</tt>');
setConst('PARSE_EmptyToBeDeleted',
       ' ** Przdn dokument, pipraven ke smazn ** ');
setConst('PARSE_From', 'z'); //ie. SomeThing *from* WantedPages, MacroSomePage
setConst('PARSE_ButtonBlock', 'Zablokovat');
setConst('PARSE_ButtonUnblock', 'Odblokovat');
setConst('PARSE_ButtonSave', 'Uloit');
setConst('PARSE_ButtonPreview', 'Nhled');

/* Template directory */
// Note the change to use only TMPL_ as prefix instead of full TEMPLATE_
setConst('TMPL_Administration', 'Administrace');
setConst('TMPL_EditDocument', 'Upravit tento dokument');
setConst('TMPL_NoEditDocument', 'Tento dokument nelze mnit');
setConst('TMPL_EditArchiveVersion', 
       'Uprav tuto <em>ARCHIVN VERZI</em> dokumentu');
// Next entry is followed by a date as produced by html_time()
setConst('TMPL_ViewDocHistory', 'Zobrazit historii dokumentu');
setConst('TMPL_DocLastModified', 'Posledn pravy');
setConst('TMPL_TwinPages', 'Stejn strnky:');
setConst('TMPL_Search', 'Hledat:');
setConst('TMPL_Editing', 'Upravit');
setConst('TMPL_WarningOtherEditing',
       'Upozornn: bhem prav dokumentu byl tento dokument zmnn nkm jinm. '.
       'Pidej svoje zmny do aktuln verze tohoto dokumentu.');
setConst('TMPL_CurrentVersion', 'Aktuln verze');
setConst('TMPL_ButtonSave', 'Uloit');
setConst('TMPL_ButtonPreview', 'Nhled');
setConst('TMPL_YourUsername', 'Tvoje uivatelsk jmno je');
setConst('TMPL_VisitPrefs', 
       'V <a href="'. $PrefsScript. '">Nastaven</a> si uprav svoje '.
       'uivatelsk jmno');
setConst('TMPL_SummaryOfChange', 'Popis provedench zmn:');
setConst('TMPL_AddToCategory', 'Zaadit dokument do kategorie:');
setConst('TMPL_YourChanges', 'Tvoje zmny');
setConst('TMPL_PreviewCurrentVersion', 'Nhled aktuln verze');
setConst('TMPL_DifferencesIn', 'Rozdly mezi');
setConst('TMPL_DifferenceBetweenVersions', 'Rozdly mezi vybranmi verzemi:');
setConst('TMPL_Find', 'Hledat');
setConst('TMPL_HistoryOf', 'Historie');
setConst('TMPL_Older', 'Star');
setConst('TMPL_Newer', 'Novj');
setConst('TMPL_ButtonComputeDifference', 'Zobrazit rozdly');
setConst('TMPL_ChangesLastAuthor', 'pravy poslednho autora:');
setConst('TMPL_Prefs', 'Nastaven');
setConst('TMPL_Previewing', 'Nhled');
setConst('TMPL_Preview', 'Nhled');

?>
